2009.04.23 - flos <lonicerae(at)gmail.com>
	* Fixed a bug of updating buddy who is not in user's buddy list

2009.02.25 - flos <lonicerae(at)gmail.com>
	* Changed text 'ZipCode' to 'Postal Code'

2009.02.24 - flos <lonicerae(at)gmail.com>
	* NEVER forget our COPYRIGHT, ;)

2009.02.24 - flos <lonicerae(at)gmail.com>
	* Changed update_class type from gint to guint32
	* Fixed a bug of displaying of memo when memo is nothing

2009.02.21 - flos <lonicerae(at)gmail.com>
	* Added 'qq_strlen' and 'qq_strcmp' funtions in qq.h
	* Fixed compiling problems with lower version of GTK+

2009.02.21 - flos <lonicerae(at)gmail.com>
	* Rewrite whole buddy memo part
	* Remove 'qq_to_utf8_len' and 'utf8_to_qq_len' functions in char_conv.c
	* Update ChangeLog, AUTHORS

2009.02.09 - Chengming Wang <tiger2007532246(at)gmail.com>
	* Rewrite buddy_memo using qq_put/qq_get series functions

2009.02.09 - Chengming Wang <tiger2007532246(at)gmail.com>
	* Added buddy 'get memo', 'remove memo', 'upload memo' functions

2009.02.08 - flos <lonicerae(at)gmail.com>
	* Fixed showing message of chat room when message comes in

2008.12.28 - flos <lonicerae(at)gmail.com>
	* Fixes #7908

2008.12.28 - flos <lonicerae(at)gmail.com>
	* References #7908

2008.12.25 - flos <lonicerae(at)gmail.com>
	* References #7821
	* Updated authors

2008.12.17 - flos <lonicerae(at)gmail.com>
	* Minor fixed in buddy_info.c

2008.12.06 - flos <lonicerae(at)gmail.com>
	* Removed version checking script in Makefiles since our developers all migrated to monotone
	* Use our development revision as OPENQ_VERSION in qq.c

2008.12.05 - flos <lonicerae(at)gmail.com>
	* Fixed a bug after propagating

2008.11.18 - ccpaging <ccpaging(at)gmail.com>
	* Fixed: IM format suuport in IM and QUN IM
	* Divide long IM message into segment and sending
	* Divide long QUN IM message in to segment and sending
	* Add some new function in im.c to put format when sending
	* Add some new function in im.c to get format when receiving
	* Need improvement:
	    Merge long IM message when receiving. Need a buffer to store segments of long IM message.
	    Send segment of long IM message one by one. Need a buffer to store segments of long IM message.

2008.11.11 - ccpaging <ccpaging(at)gmail.com>
	* Change QQ number to unsigned long
	* Change Qun ID and Qun extend ID to unsigned long
	* Rewrite smiley convert function, use qsort and bsearch
	* Update smiley map according EVA and pidgin theme file
	* Support long IM message in private and Qun

2008.10.27 - ccpaging <ccpaging(at)gmail.com>
	* Fixed a bug in group_join.c

2008.10.30 - flos <lonicerae(at)gmail.com>
	* Fixed a bug which made xgettext failed in buddy_info.c
	* Fixed a bug in Makefile.am and Makefile.mingw
	* Updated acknowledgement in qq.c

2008.10.28 - flos <lonicerae(at)gmail.com>
	* Updated AUTHORS

2008.10.27 - ccpaging <ccpaging(at)gmail.com>
	* Fixed a bug in buddy_info.c

2008.10.27 - ccpaging <ccpaging(at)gmail.com>
	* Update 'buddy_adding' protocol

2008.10.22 - ccpaging <ccpaging(at)gmail.com>
	* 20081022

2008.10.20 - ccpaging <ccpaging(at)gmail.com>
	* Support incoming authorization of 'buddy_adding' protocol of QQ2007/2008

2008.10.14 - ccpaging <ccpaging(at)gmail.com>
	* 2007 remove buddy ok
	* Removed group_search.c/h

2008.10.10 - ccpaging <ccpaging(at)gmail.com>
	* Support part of 'buddy' protocol of QQ2007/2008

2008.10.10 - ccpaging <ccpaging(at)gmail.com>
	* Keep group_search.c/h for later use
	* Update 'group'

2008.10.09 - ccpaging <ccpaging(at)gmail.com>
	* 20081009-1

2008.10.09 - ccpaging <ccpaging(at)gmail.com>
	* Update 'group' protocol
	* Functions of group_find, group_free, group_search merged into group_join and group_internal
	* Removed group_find.c/h, group_free.c/h, group_search.c/h

2008.10.08 - ccpaging <ccpaging(at)gmail.com>
	* Update 'group' protocol

2008.10.08 - ccpaging <ccpaging(at)gmail.com>
	* 20081008-1

2008.10.08 - ccpaging <ccpaging(at)gmail.com>
	* Update group part
	* Delete some meaningless functions and data
	* Added 'change my icon'

2008.10.08 - lonicerae <lonicerae(at)gmail.com>
	* Update Makefile.mingw

2008.10.08 - ccpaging <ccpaging(at)gmail.com>
	* Fixed QQ_BUDDY_ICON_DIR problem

2008.10.07 - lonicerae <lonicerae(at)gmail.com>
	* Update 'version display'

2008.10.07 - lonicerae <lonicerae(at)gmail.com>
	* Added some defensive code for 'action' series functions of qq.c

2008.10.07 - ccpaging <ccpaging(at)gmail.com>
	* Update buddy icon

2008.10.07 - ccpaging <ccpaging(at)gmail.com>
	* Update qq_buddy

2008.10.07 - ccpaging <ccpaging(at)gmail.com>
	* Update qun conversation

2008.10.05 - lonicerae <lonicerae(at)gmail.com>
	* Bug fix in 'About OpenQ' dialog

2008.10.05 - lonicerae <lonicerae(at)gmail.com>
	* Added 'About OpenQ' dialog

2008.10.05 - ccpaging <ccpagint(at)gmail.com>
	* Add my uid into buddy list
	* Fixed a minor bug in qq_create_buddy. Not get new buddy's info.
	* There are 38 fields in protocol 2008, one more than 2005/2007.
	* The packet of Modifing buddy info is changed. Need sample to fix it.

2008.10.04 - ccpaging <ccpagint(at)gmail.com>
	* Update protocol for 2007
	* Code cleanup

2008.10.04 - lonicerae <lonicerae(at)gmail.com>
	* fixed a bug in qq_base.c

2008.10.03 - ccpaging <ccpaging(at)gmail.com>
	* 2007 protocol:
		1. fixed 'get room info'
		2. fixed 'get buddy level'

2008.10.02 - ccpaging <ccpaging(at)gmail.com>
	* Added 'Captcha Display' function
	* QQ2007 for openq, programed by Emil Alexiev:
		1. Most functions from patch written by Emil Alexiev merged into trunk, except 'buddy operations'
		2. 'online buddy status' and 'qun buddies' still have problems
	* QQ2008 console client, programed by Shrimp:
		1. 'before login' and 'keep alive' parts merged into trunk

2008.09.30 - ccpaging <ccpaging(at)gmail.com>
	* Successfully login using 2007/2008 protocols

2008.09.29 - ccpaging <ccpaging(at)gmail.com>
	* 'Check Password' function for protocol 2007/2008

2008.09.28 - ccpaging <ccpaging(at)gmail.com>
	* The source is only for debug, not for user:
		1. Implement new QQ protocol 2007/2008, include login and change status
		2. Check 2005's login reply packet, get last 3 login time.
		3. Server's notice and news is displayed in self buddy (The new buddy created in buddy list).
		4. The notice messages when adding/removing QQ Qun's buddy displayed in char conversation. They are displayed as purple notify windows in the past.
		5. The notice messages when adding/removing buddy displayed in self buddy's conversation. They are displayed as purple notify windows in the past.
		6. Client version can be selected in  account option. Now only qq2005 is working, other new version is only for debug.

2008.09.26 - ccpaging <ccpaging(at)gmail.com>
	* Added 'Request/Add/Remove Buddy' functions

2008.09.19 - ccpaging <ccpaging(at)gmail.com>
	* Rewrite buddy modify info, there is a ticket for this problem
	* Use ship32 to trans action code between request packet and reply packet process

2008.09.15 - csyfek <csyfek(at)gmail.com>
	* im.pidgin.pidgin.openq branch

2008.09.05 - ccpaging <ccpaging(at)gmail.com>
	* Filter chars 0x01-0x20 in nickname

2008.09.05 - ccpaging <ccpaging(at)gmail.com>
	* Fixed compilation even pidgin-udp-patch not applied
	* Place and analysis 'before login packet' after login. packages will be updated slowly and server may send lots of 'server command packet', while 'before login packet' is placed after 'finished update'

2008.09.02 - ccpaging <ccpaging(at)gmail.com>
	* Bugfix: can not send message to the QUN blocked adding
	* Tickets:
		Fixes #6957

2008.09.02 - ccpaging <ccpaging(at)gmail.com>
	* Use new tactics of information update:
		1. send next package till the previous package received
		2. fix duplicated get_room_info and get_room_buddies commands

2008.08.16 - ccpaging <ccpaging(at)gmail.com>
	* Rename group to room. If you used pidginqq before, this may create a new room with same title, you may delete old one
	* Replace purple_debug with purple_debug_info, purple_debug_warning, purple_debug_error
	* Add server notice and server new, and two options to turn on/off
	* Minor modify for reducing transaction's debug infor
	* Minor modifies for system notice and QQ news.
	* Add 4 new strings need translate compare with p10.
	* Tickets:
		Fixes #6990

2008.08.10 - csyfek <csyfek(at)gmail.com>
	* Commit to Pidgin

2008.08.07 - ccpaging <ccpaging(at)gmail.com>
	* Support managing multi-connections according to simple.c

2008.08.06 - ccpaging <ccpaging(at)gmail.com>
	* Rename names of variables, Group, to Room
	* Functions of group_network merged into qq_network and qq_process
	* Canceled managing glist of group packet, add sub_cmdd and room_id  to transaction
	* Fixed error of demo group:
		If 'room list' and 'room infor' are not setup, response received from server will emits 'room_id = 0' packet.

2008.08.04 - ccpaging <ccpaging(at)gmail.com>
	* Use new crypt/decrypt functions
	* Rename crypt.c/h to qq_crypt.c/h
	* Clean code of decrypt functions
	* Fixed decryption failure

2008.08.04 - csyfek <csyfek(at)gmail.com>
	* Update AUTHORS

2008.08.03 - csyfek <csyfek(at)gmail.com>
	* Commit lost files to Pidgin

2008.08.02 - csyfek <csyfek(at)gmail.com>
	* Commit to Pidgin
	* Tickets:
		Fixes #1861
		Fixes #1902
		References #5112

2008.08.02 - ccpaging <ccpaging(at)gmail.com>
	* Store all keys and md5 values of qq_data in char[QQ_KEY_LENGTH]
	* Use random value in inikey
	* TEA header padding in crypt.c
	* Rewrite login part of qq_process

2008.07.31 - ccpaging <ccpaging(at)gmail.com>
	* Fixed: send reply when get duplicate server command. The server may not get our reply before.
	* Tag custom picture as text "(Broken)"

2008.07.30 - ccpaging <ccpaging(at)gmail.com>, csyfek <csyfek(at)gmail.com>
	* Change some debug message
	* Modify buddy status flag according to eva for QQ2006
	* Modify buddy status parse and correspond to eva2
	* Add getIP/putIP functions to packet_parse.c, and replace some gen_ip_str
	* Replace guint32 *ip with struct in_addr, and reduce g_new/g_free operation
	* Source file changed:
   		Merge buddy_status into buddy_list
   		Change login_logout to qq_base
   		Merge keep_alive into qq_base
   		New qq_process extract from qq_network
	* Fixed: Byte alignment bug in crypt.c, tested in ARM PDA
	* Fixed: group chat message may get in before getting group info, and so group info is empty
	* Add qq_send_cmd_group_get_group_info when joined a group chat in group_im.c
	* Add some new group command identify according eva but further program
	* Add some new QQ client version identify
	* Fixed: Identify buddy's client version by IM packet, and not by status
	* Add some new info in buddy's tooltip text
	* Add video falg to buddy's emblem. But those flag in buddy status may not prasing correctly
	* Use new timeout function to handle send keep_alive, resend packet, update buddy status
	* Add new advanced options:
		The end user may change interval of keep_alive, resend packet, update buddy status to feed their need.
		For example, saving network flow when use mobile phone.
		Keep alive packet must be sent in 60-120 seconds whatever client rcved data of not.
		The intervals of keep alive and update status should be multiple of resend's interval,
		Since we use counter not time() in a single timeout function for efficiency.
	* Rewrite qq_trans.c, and use one g_list to manage:
		Store server packet before login, and prase all of them when get login
		Store client send packet for resend scanning, confirm server reply, filter duplicate server reply
		Store server packet for filter out duplicate
	* Add QQ_MSG_SYS_NOTICE = 0x06 in sys_msg.c
	* Rewrite qq_proc_cmd_reply and qq_proc_cmd_server:
		In QQ protocol, one packet reply may need a new packet send later.
		We may call it packet trigger. The triggers always is hided in every qq_process_reply.
		Now we try to extract those triggers and put into a single function,
		and then every trigger should be obviously and easy to manage.

2008.07.12 - ccpaging <ccpaging(at)gmail.com>
	* Fixed: Always lost connection. Now send keep alive packet in every 30 seconds
	* Minor fix for debug information
	* Filter \r\n and replace with SPCAE in group notive
	* Fixed a memory leak
	* Tickets:
	* Fixes #4024.

2008.06.29 - csyfek <csyfek(at)gmail.com>
	* Minor bug fix
	* Add some doxygen syntax for preparing development documentation
	* References #6199

2008.06.28 - ccpaging <ccpaging(at)gmail.com>, moo <phpxcache(at)gmail.com>
	* Patches from moo<phpxcache@gmail.com> and ccpaging<ccpaging@foxmail.com>.
	* Tickets:
	* Fixes #4956.
	* Fixes #2998.

2008.06.07 - ccpaging <ccpaging(at)gmail.com>, csyfek <csyfek(at)gmail.com>
	* Clean code and apply patches from QuLogic

2008.05.19 - ccpaging <ccpaging(at)gmail.com>, csyfek <csyfek(at)gmail.com>
	* Reconnect server 5 time in 5000 ms, when connect failed
	* Rename sendqueue.c/sendqueue.h to qq_trans.c/qq_trans.h
	* Rewrite packet_process
	* Rewrite qq_send_cmd
	* Create server list, try to connect every server when failed

2008.05.14 - ccpaging <ccpaging(at)gmail.com>
	* Move function for before login packets storing to sendqueue
	* Use transaction data structure to store before login packets
	* Rewrite tcp_pending and packet_process in qq_network.c

2008.05.09 - ccpaging <ccpaging(at)gmail.com>
	* Remove function _create_packet_head_seq in qq_network.c
	* Create new function encap in qq_netowork.c
	* Clean code of qq_send_packet_request_login_token and qq_send_packet_login in login_out.c

2008.05.09 - ccpaging <ccpaging(at)gmail.com>
	* Clean code of packet_parse.c, enable PARSER_DEBUG
	* Rewrite send_queue

2008.05.08 - ccpaging <ccpaging(at)gmail.com>
	* Rewrite qq_network
	* Add srv resolve function when qq_login
	* Merge function _qq_common_clean in qq_proxy.c to qq_disconnect
	* Move orignal qq_disconnect to qq_close
	* qq_data alloc in qq_open and release in qq_close
	* Network connect of QQ is created in qq_connect, and release in qq_disconnect

2008.05.05 - ccpaging <ccpaging(at)gmail.com>
	* Merge function _qq_common_clean in qq_proxy.c to qq_disconnect
	* Move orignal qq_disconnect to qq_close
	* qq_data alloc in qq_open and release in qq_close
	* Network connect of QQ is created in qq_connect, and release in qq_disconnect

2008.05.05 - ccpaging <ccpaging(at)gmail.com>
	* Add qq_hex_dump function

2008.04.25 - ccpaging <ccpaging(at)gmail.com>, csyfek <csyfek(at)gmail.com>
	* Rewrite read_packet and create_packet functions, use qq_put and qq_get functions instead
	* New logic in accord with protocol models to handle packets, some related functions rewritten

2008.03.24 - ccpaging <ccpaging(at)gmail.com>
	* Remove qq_crypt function in crypt.c, use qq_crypt and qq_decrypt directly

** since pidgin-2.4.0 ***
